# Списки
"""1. Создайте два любых списка и свяжите их с переменными."""

list_1 = [1, 2, 3, 4, 5]
list_2 = [6, 7, 8, 9, 10]


"""2. Извлеките из первого списка второй элемент."""

print(list_1[1])


"""3. Измените во втором списке последний элемент.
Выведите список на экран."""

list_2[-1] = 11
print(list_2)


"""4. Соедините оба списка в один, присвоив результат новой переменной.
Выведите получившийся список на экран."""

joint_list = list_1 + list_2
print(joint_list)


"""5. "Снимите" срез из соединенного списка так, чтобы туда попали некоторые
части обоих первых списков. Срез свяжите с очередной новой переменной.
Выведите значение этой переменной."""

print(len(list_1))
print(len(list_2))
slice_of_string = joint_list[3:-3]
print(slice_of_string)


"""6. Добавьте в список два новых элемента и снова выведите его."""

add_list = [111, 222]
joint_list.extend(add_list)
print(joint_list)


"""7. Даны списки:
a = [1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89];
b = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13].
Нужно вернуть список, который состоит из элементов,
общих для этих двух списков. -- !не использовать циклы"""

a = [1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89]
b = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13]

# way 1
print(list(set(a) & set(b)))

# way 2
print([i for i in b if i in a])


"""8. Есть список: [1, 2, 3, 4, 3, 2, 5, 1, 4, 6, 7, 1, 8, 2, 3]
оставить в нем только уникальные значения. !не использовать циклы"""

list_3 = [1, 2, 3, 4, 3, 2, 5, 1, 4, 6, 7, 1, 8, 2, 3]

# way 1
unique_list_3 = list(set(list_3))
print(unique_list_3)


# Логические операторы
"""1. Присвойте двум переменным любые числовые значения."""

a = 10
b = 15


"""2. Используя переменные из п. 1, с помощью оператора and составьте два
сложных логических выражения, одно из которых дает истину, другое – ложь."""

print(a < 25 and b == 15 and (a + b) == 25)  # true
print(a == 10 and b > a and (b * a) == 1)  # false


"""3. Аналогично выполните п. 2, но уже с оператором or."""

print(a < 25 or b == 16 or (a + b) == 25)  # true
print(a == 11 or b < a or (b * a) == 1)  # false


"""4. Попробуйте использовать в логических выражениях переменные строкового
типа. Объясните результат."""

str_1 = "section"
str_2 = "street"
print(str_1 > str_2)  # сравнение строк происходит по буквам, в этом примере
# при сравнении 2ой буквы строк вернется False и процесс сравнения остановится,
# т.к. код буквы e < кода буквы t


"""5. Напишите программу, которая запрашивала бы у пользователя два числа и
выводила бы True или False в зависимости от того, больше первое число второго
или нет. (используйте функцию input() )"""

a = int(input("Enter the first number: "))
b = int(input("Enter the second number: "))
print(a > b)


# Словари
"""1. Создайте словарь, связав его с переменной school, и наполните его
данными, которые бы отражали количество учащихся в десяти разных классах
(например, 1а, 1б, 2б, 6а, 7в и т.д.)."""

school = {"1а": 10, "8а": 17, "1б": 15, "2а": 20, "7б": 23,
          "10а": 17, "10б": 25, "5а": 20, "5б": 15, "6б": 17}
print(school)


"""2. Узнайте сколько человек в каком-нибудь классе."""

print(school["10б"])  # amount of pupils in 10б class


"""3. Представьте, что в школе произошли изменения, внесите их в словарь:
◦ в трех классах изменилось количество учащихся;
◦ в школе появилось два новых класса;
◦ в школе расформировали один из классов."""

changed_amount = {"1а": 11, "8а": 18, "1б": 16}  # changed amount of pupils
school.update(changed_amount)
school["4а"] = 15  # new class is added
school["4б"] = 20  # new class is added
del school["6б"]  # 1 class is removed


"""4. Выведите содержимое словаря на экран."""

print(school)


# Кортежи
"""1. Создайте кортеж с цифрами от 0 до 9 и посчитайте сумму.
(ожидаемый вывод суммы = 45)"""

tuple_1 = tuple([i for i in range(10)])
print(sum(tuple_1))


"""2. Есть кортеж long_word = ('т', 'т', 'а', 'и', 'и', 'а', 'и', 'и', 'и',
'т', 'т', 'а', 'и', 'и', 'и', 'и', 'и', 'т', 'и') распечатайте на экран
количество букв “т”, “и”, “а”"""

long_word = ("т", "т", "а", "и", "и", "а", "и", "и", "и", "т",
             "т", "а", "и", "и", "и", "и", "и", "т", "и")
print(long_word.count("т"))
print(long_word.count("и"))
print(long_word.count("а"))


"""3. Допишите скрипт для расчета средней температуры.
Постарайтесь посчитать количество дней на основе week_temp.
Так наш скрипт сможет работать с данными за любой период."""

week_temp = (26, 29, 34, 32, 28, 26, 23)
sum_temp = sum(week_temp)
days = len(week_temp)
mean_temp = sum_temp / days
print(int(mean_temp))
